var GoogleLogin = {
	data: {
		clientId: "313610222031-7goep4phkr484jtlgvi7iatiiu29gsas",
		secret: "ik20ylx4NBhLUGdFr2Beu2US"
	},
	token: {},
	authWindow: null,

	logIn: function() {
		var urlAuth = "https://accounts.google.com/o/oauth2/auth?"
			+ "scope=https%3A%2F%2Fwww.googleapis.com%2Fauth%2Fgames+https%3A%2F%2Fwww.googleapis.com%2Fauth%2Fappstate&"
			+ "redirect_uri=http://localhost&"
			+ "response_type=code&"
			+ "client_id=" + GoogleLogin.data.clientId + "&"
			+ "access_type=offline";

		GoogleLogin.authWindow = window.open(urlAuth, '_blank', 'location=no,toolbar=no');
		GoogleLogin.authWindow.addEventListener('loadstart', GoogleLogin.parseRedirectUrl);
		GoogleLogin.authWindow.addEventListener('close', function() {
			GoogleLogin.authWindow = null;
		});
	},

	parseRedirectUrl: function(e){
		var url = e.url;
		var thereIsCode = url.indexOf("code=");
		var thereIsError = url.indexOf("error=");

		if(thereIsCode != -1){
			GoogleLogin.authWindow.close();
			GoogleLogin.authWindow = null;
			var toMatch = "code=([^&#]*)";
			var regex = new RegExp(toMatch);
			var result = regex.exec(url);
			
			if(result != null){
				GoogleLogin.requestTokens(result[1]);
			}
		}
		else if(thereIsError != -1) {
			GoogleLogin.authWindow.close();
			GoogleLogin.authWindow = null;
			GoogleLogin.token = null;
			localStorage["access_token"] = null;
		}		
	},

	requestTokens: function(code) {
		$.ajax({
		    beforeSend: function(xhrObj){
		        xhrObj.setRequestHeader("Content-Type","application/x-www-form-urlencoded");
		    },
		    type: "POST",
		    url: 'https://accounts.google.com/o/oauth2/token',       
		    data: {
                    code: code,
                    client_id: GoogleLogin.data.clientId,
                    client_secret: GoogleLogin.data.secret,
                    redirect_uri: "http://localhost",
                    grant_type: 'authorization_code'
                },               
		}).done(function(data) {
        	console.log("requestTokens", data);

			if(data.access_token){
				localStorage["access_token"] = data.access_token;
				localStorage["id_token"] = data.id_token;
				localStorage["refresh_token"] = data.refresh_token;
				localStorage["refresh_time"] = (new Date()).getTime() + 1000 * data.expires_in;

				GoogleLogin.token = data;
				GoogleLogin.setupGAPI();
			}
			else {
				GoogleLogin.token = null;
				localStorage["access_token"] = null;
			}
        }).fail(function(response) {
        	console.log("fail request", response);
        });
	},

	refreshTokens: function(refreshToken) {
		$.ajax({
		    beforeSend: function(xhrObj){
		        xhrObj.setRequestHeader("Content-Type","application/x-www-form-urlencoded");
		    },
		    type: "POST",
		    url: 'https://accounts.google.com/o/oauth2/token',       
		    data: {
                    refresh_token: refreshToken,
                    client_id: GoogleLogin.data.clientId,
                    client_secret: GoogleLogin.data.secret,
                    grant_type: 'refresh_token'
                },               
		}).done(function(data) {
        	console.log("refreshTokens", data);

			if(data.access_token){
				localStorage["access_token"] = data.access_token;
				localStorage["refresh_time"] = (new Date()).getTime() + 1000 * data.expires_in;

				GoogleLogin.token = data;
				GoogleLogin.setupGAPI();
			}
			else {
				GoogleLogin.token = null;
				localStorage["access_token"] = null;
				$(document).trigger("notLoggedIn");
			}
        }).fail(function(response) {
        	console.log("fail refresh", response);
        	// refresh failed we need to take a login action
        	if((response.status === 400 || response.responseText.indexOf("invalid_grant") !== -1)
        	&& GoogleAPI.logged === true) {
				$(document).trigger("loggedOut");        		
        	}
        	else {
        		$(document).trigger("notLoggedIn");
        	}
        });
	},

	checkLogin: function(callback) {
		var accessToken = localStorage["access_token"];

		if(localStorage.getItem("access_token") === null || localStorage.getItem("access_token") === "null") {
			GoogleLogin.token.access_token = null;
		}

		if(GoogleLogin.token.access_token !== null && typeof(GoogleLogin.token) !== 'undefined'){
			var refreshTime = localStorage.getItem("refresh_time");
			var refreshToken = localStorage.getItem("refresh_token");

			if(refreshTime !== null && (new Date()).getTime() < refreshTime) {
				GoogleLogin.token.access_token = accessToken;
				GoogleLogin.token.refresh_token = refreshToken;
				GoogleLogin.token.refresh_time = refreshTime;
				GoogleLogin.token.token_type = "Bearer";

				callback();
				return true;
			}
			else if(refreshToken === null) {
				$(document).trigger("notLoggedIn");
				return false;
			}
			else {
				GoogleLogin.refreshTokens(refreshToken);
			}
		}
		else {
			$(document).trigger("notLoggedIn");
			return false;
		}
	},

	setupGAPI: function() {
		gapi.auth.setToken("token", GoogleLogin.token);

		GoogleAPI.checked = true;
		GoogleAPI.logged = true;
		GoogleAPI.loadClient();

		$(document).trigger("loggedIn");
	},

	loggedOut: function() {
		GoogleLogin.token = {};

		localStorage.removeItem("access_token");
		localStorage.removeItem("refresh_token");
		localStorage.removeItem("refresh_time");
	}
};
